<script setup lang="ts">
import { object, string, array, type InferType } from 'yup'
import type {FormSubmitEvent} from "#ui/types";
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";

const types = ['json', 'xml']
const alert_data = ref([])
const loading = ref(false)

const schema = object({
  name: string().required(),
  type: string().required(),
  flux_url: string().required(),
  alert_array: string().required(),
  alert: string().required(),
  alert_data: string()
})

type Schema = InferType<typeof schema>

const state = reactive({
  name: undefined,
  type: undefined,
  flux_url: undefined,
  alert_array: undefined,
  alert: undefined,
  alert_data: undefined
})

const links = [{
  label: 'Home',
  icon: 'i-heroicons-home',
  to: '/feed'
}, {
  label: 'Flux',
  icon: 'i-heroicons-square-3-stack-3d',
  to: '/flux'
}, {
  label: 'Nouveau',
  icon: 'i-heroicons-document-plus'
}]

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const toast = useToast()
const router = useRouter()
const error = ref('')
async function onSubmit (event: FormSubmitEvent<Schema>) {
  console.log(event.data)
  loading.value = true
  const data = ref({
    name: event.data.name,
    flux_url: event.data.flux_url,
    type: event.data.type,
    alert_array: event.data.alert_array,
    alert: event.data.alert,
    alert_data: alert_data.value
  })

  const response = await $api.createFlux(data.value)
  if (response) {
    toast.add({ title: 'Flux ajouté' })
    await router.push('/flux')
  } else {
    error.value = 'Un problème est survenu'
  }
  loading.value = false
}

function add () {
  if (state.alert_data !== '') {
    alert_data.value.push(state.alert_data)
    state.alert_data = ''
    console.log(alert_data.value)
  }
}
</script>

<template>
  <div class="py-8 mt-10 md:mt-0 px-4 lg:py-16 lg:px-12">
    <section class="bg-white dark:bg-gray-900">
      <UBreadcrumb :links="links" />
      <div class="py-8 px-4 mx-auto max-w-2xl lg:py-16">
        <h2 class="mb-4 text-xl font-bold text-gray-900 dark:text-white">
          Ajout nouveau flux
        </h2>
        <p>{{ error }}</p>
        <UForm :schema="schema" :state="state" @submit="onSubmit">
          <div class="grid gap-4 sm:grid-cols-2 sm:gap-6">
            <div class="sm:col-span-2">
              <UFormGroup label="Nom flux" name="flux-name">
                <UInput type="text" v-model="state.name" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Url flux" name="flux-url">
                <UInput type="text" v-model="state.flux_url" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Type flux" name="flux-type">
                <USelect v-model="state.type" :options="types" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Array 1 flux" name="flux-array-1">
                <UInput text="text" v-model="state.alert" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Array 2 flux" name="flux-array-2">
                <UInput text="text" v-model="state.alert_array" />
              </UFormGroup>
            </div>
            <div class="sm:col-span-2">
              <UFormGroup label="Array" name="flux-array">
                {{ alert_data }}
                <UInput text="text" v-model="state.alert_data" />
                <UButton @click="add">Add</UButton>
              </UFormGroup>
            </div>
          </div>
          <UButton type="submit" :loading="loading" class="w-full text-white bg-primary-600 hover:bg-primary-700 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Ajouter flux
          </UButton>
        </UForm>
      </div>
    </section>
  </div>
</template>